/*

   Programa de lectura de un directorio remoto en base a 
   sockets de la familia Unix
   Codigo del cliente.
 
   Nombre Archivo: unclient.c
   Fecha: octubre 97

   Compilacion:cc unclient.c -lnsl -lsocket -o unclient

   Ejecucion: unclient <directorio>

*/

#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>

#define  DIRSIZE  8192   /* longitud maxima parametro entrada salida */


main(argc, argv)
   int    argc;
   char  *argv[];
{
	char  dir[DIRSIZE];	        /* parametro entrada y salida */
	int   sd;                       /* descriptor del socket */
	struct sockaddr_un   sin; 	/* direcciones socket */


/* verificacion de los parametros de entrada */

        if (argc != 2) {
                fprintf(stderr,"Error, uso: %s <directorio> \n",argv[0]);
                exit(1);
        }

/* asignacion valores a la direccion */

	strcpy(sin.sun_path, "./socket");
        sin.sun_family = AF_UNIX;


/* obtencion de un socket tipo AF_UNIX  (igual que el servidor) */

	if ( (sd = socket(AF_UNIX, SOCK_STREAM, 0)) == -1) {
		perror("socket");
		exit(1);
	}

/* conectandose  al archivo ./socket */

	if ( connect(sd, (struct sockaddr *)&sin, sizeof(sin)) == -1) {
		perror("connect");
		exit(1);
	}

/* enviar mensaje al servidor */

        strcpy(dir, argv[1]);
	if ( write(sd, dir, sizeof(dir)) == -1) {
		perror("write");
		exit(1);
	}

/* esperar por la respuesta */

	if ( read(sd, dir, sizeof(dir)) == -1) {
		perror("read");
		exit(1);
	}

/* imprimir los resultados y cerrando la conexion del socket */

	printf("%s \n", dir);
	close(sd);
}
