/*

   Programa de lectura de un directorio remoto en base a 
   sockets de la familia Unix
   Codigo del servidor.

   NOTA: Difiere del de las notas en el hecho de que este incluye
   una funcion de aborto en caso de teclear <ctrl><c>. Tambien
   la variable sin se cambio por sind
 
   Nombre Archivo: unserver.c
   Fecha: octubre 97

   Compilacion:cc unserver.c lee_dir.c -lnsl -lsocket -o unserver

   Ejecucion: unserver &

*/


#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <signal.h>

#define  DIRSIZE   8192    /* longitud maxima entrada/salida */

int     sd,   sd_actual;	/* descriptores de sockets */
struct sockaddr_un   sind; 	/* direcciones socket */

/*  procedimiento de aborte del servidor */

void aborta()
{
   printf("....abortando el proceso servidor \n");
   close(sd);
   close(sd_actual);
   unlink("./socket");
   exit(1);
}


main()
{
	char  dir[DIRSIZE];	/* parametro entrada y salida */


        signal(SIGINT, aborta);

/* asignacion valores a la direccion  */

	strcpy(sind.sun_path, "./socket");
 	sind.sun_family = AF_UNIX;

/* obtencion de un socket tipo AF_UNIX   */

	if ( (sd = socket(AF_UNIX, SOCK_STREAM, 0)) == -1) {
		perror("socket");
		exit(1);
	}

/* asociando el socket al archivo ./socket */

	if ( bind(sd, (struct sockaddr *)&sind, sizeof(sind)) == -1 ) {
		perror("bind");
		exit(1);
	}

/* ponerse a escuchar a traves del socket */	

	if ( listen(sd, 5) == -1 ) {
		perror("listen");
		exit(1);
	}

/* esperando que un cliente solicite un servicio */

	if ( (sd_actual = accept(sd, 0, 0)) == -1) {
		perror("accept");
		exit(1);
	}

/* tomar un mensaje del cliente */

	if ( read(sd_actual, dir,  sizeof(dir), 0) == -1) {
		perror("read");
		exit(1);
	}

/* leyendo el directorio */

	lee_dir(dir);
 
/* enviando la respuesta del servicio */

	if ( write(sd_actual, dir, sizeof(dir)) == -1) {
		perror("write");
		exit(1);
	}

/* cerrar los dos sockets */

	close(sd_actual);   close(sd);

/* no olvidar realizar un poco de limpieza */
	unlink("./socket");

}


